----------------------------------------------------------------------------------------------------
-- SuperCupUtil
----------------------------------------------------------------------------------------------------
-- Purpose: Utility class for the super cup.
--
-- Copyright (c) Wopster, 2020
----------------------------------------------------------------------------------------------------

---@class SuperCupUtil
SuperCupUtil = {}

function SuperCupUtil.addToListIfNotExists(item, list)
    if item == nil then
        return
    end

    if not ListUtil.hasListElement(list, item) then
        ListUtil.addElementToList(list, item)
    end
end

---Get class object to dynamically load classes from the XML.
---Obtained from the FS17 code base, still seems to work.
function SuperCupUtil.getClassObject(className)
    local parts = StringUtil.splitString(".", className)
    local numParts = table.getn(parts)
    local currentTable = _G[parts[1]]

    if type(currentTable) ~= "table" then
        return nil
    end

    for i = 2, numParts do
        currentTable = currentTable[parts[i]]
        if type(currentTable) ~= "table" then
            return nil
        end
    end

    return currentTable
end

function SuperCupUtil.millisecondsToClockString(milliseconds)
    milliseconds = tonumber(milliseconds)

    if milliseconds <= 0 then
        return "--:--:--"
    end

    local millis = milliseconds % 1000
    local t = milliseconds * 0.001
    local seconds = t % 60
    t = t / 60
    local minutes = t % 60

    return ("%02d:%02d:%03d"):format(minutes, seconds, millis)
end
