----------------------------------------------------------------------------------------------------
-- CheckpointAction
----------------------------------------------------------------------------------------------------
-- Purpose: Base class for checkpoint actions.
--
-- Copyright (c) Wopster, 2020
----------------------------------------------------------------------------------------------------

---@class CheckpointAction
CheckpointAction = {}

local CheckpointAction_mt = Class(CheckpointAction)

---Creates a CheckpointAction instance.
---@return CheckpointAction
function CheckpointAction:new(checkpoint, mt)
    local self = setmetatable({}, mt or CheckpointAction_mt)

    self.checkpoint = checkpoint
    self.fulfilled = false

    return self
end

function CheckpointAction:delete()
end

function CheckpointAction:reset()
    self.fulfilled = false
end

function CheckpointAction:loadFromXML(xmlFile, baseKey)
    return true
end

function CheckpointAction:isFulfilled()
    return self.fulfilled
end
