---@class SuperCupVehicle
SuperCupVehicle = {}
SuperCupVehicle.MOD_NAME = g_currentModName

function SuperCupVehicle.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Drivable, specializations)
end

function SuperCupVehicle.registerFunctions(vehicleType)
    SpecializationUtil.registerFunction(vehicleType, "setAllowDriveSuperCup", SuperCupVehicle.setAllowDriveSuperCup)
    SpecializationUtil.registerFunction(vehicleType, "getAllowDriveSuperCup", SuperCupVehicle.getAllowDriveSuperCup)
end

function SuperCupVehicle.registerOverwrittenFunctions(vehicleType)
    SpecializationUtil.registerOverwrittenFunction(vehicleType, "getIsVehicleControlledByPlayer", SuperCupVehicle.getIsVehicleControlledByPlayer)
end

function SuperCupVehicle.registerEventListeners(vehicleType)
    SpecializationUtil.registerEventListener(vehicleType, "onLoad", SuperCupVehicle)
    SpecializationUtil.registerEventListener(vehicleType, "onDelete", SuperCupVehicle)
end

---Called on load.
function SuperCupVehicle:onLoad(savegame)
    self.spec_superCupVehicle = self[("spec_%s.superCupVehicle"):format(SuperCupVehicle.MOD_NAME)]
    local spec = self.spec_superCupVehicle
    spec.allowDriving = false
end

---Called on delete.
function SuperCupVehicle:onDelete()
end

function SuperCupVehicle:setAllowDriveSuperCup(allowDriving)
    local spec = self.spec_superCupVehicle
    spec.allowDriving = allowDriving
end

function SuperCupVehicle:getAllowDriveSuperCup()
    local spec = self.spec_superCupVehicle
    return spec.allowDriving
end

function SuperCupVehicle:getIsVehicleControlledByPlayer(superFunc)
    return superFunc(self) and self:getAllowDriveSuperCup()
end
